> For the complete documentation index, see [llms.txt](https://sugoi.gitbook.io/lanraragi/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://sugoi.gitbook.io/lanraragi/api-documentation/getting-started.md).

# Getting started

The Client API allows you to communicate with a running LANraragi instance from a dedicated client. All the (public)endpoints below can be tested on the demo!

## Authenticating with the API

Most of the API endpoints require a form of authentication.

Said authentication is provided by a configurable **API Key,** which is set by the user in the LRR settings.

This key must be added to your calls as an `Authorization: Bearer` header, with the key encoded in base64:

```bash
DELETE /api/search/cache HTTP/1.1
Accept: application/json
Authorization: Bearer SEVBVEhFTg==
```

If you fail to meet this requirement, the API endpoint will return error 401 and the following JSON:

```
{
    "error":"This API is protected and requires login or an API Key."
}
```

{% hint style="warning" %}
If the user's LRR installation is running under **No-Fun Mode**, all API methods will be locked behind the key.\
Empty API Keys will **not** work, even if there's no key set in Configuration.
{% endhint %}

Private endpoints will be indicated by a 🔑 symbol next to their name in the following sections.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://sugoi.gitbook.io/lanraragi/api-documentation/getting-started.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
